
print(...)

local _, _, stash = ...
if not stash then
  stash = {}
  stash.zone = {
  {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [14] = 1,
   [15] = 1,
   [16] = 1,
   [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [14] = 1,
   [15] = 1,
   [16] = 1,
   [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [13] = 2,
   [14] = 2,
   [15] = 1,
   [16] = 1,
   [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [13] = 2,
   [14] = 2,
   [15] = 1,
   [16] = 1,
   [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [13] = 2,
   [14] = 2,
   [15] = 2,
   [16] = 2,
   [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }, {
     [17] = -1,
   [18] = -1,
   [19] = -1,
   [20] = -1
  }
 }
 
 stash.doors = {
   [10] = {
     [16] = true
  },
  [12] = {
     [14] = true
  }
 }
 
 stash.racks = {
   [9] = {
     [14] = true,
   [15] = true,
   [16] = true
  },
  [10] = {
     [14] = true
  },
  [11] = {
     [15] = false,
   [16] = true
  },
  [12] = {
     [16] = true
  }
 }
end
local zone, doors, racks = stash.zone, stash.doors, stash.racks

print(persistence.stringize(zone))
print(persistence.stringize(doors))
print(persistence.stringize(racks))

local smashed = {}

local function standardize(x)
  for y = 0, 21 do
    if not x[y] then x[y] = {} end
  end
end
standardize(zone)
standardize(doors)
standardize(racks)
standardize(smashed)

local function gitem(x, y) return zone[x][y] end
local function get_door(x, y) return doors[x][y] end
local function get_rack(x, y) return racks[x][y] end
local function set_rack(x, y, z) racks[x][y] = z end

local function get_smashed(x, y) return smashed[x][y] end
local function set_smashed(x, y, z) smashed[x][y] = z end

local deadwalls = {}
local function deadwall_make(sx, sy, ex, ey)
  return string.format("%d.%d.%d.%d", sx, sy, ex, ey)
end
local function deadwall(sx, sy, ex, ey)
  sx, ex = sort2(sx, ex)
  sy, ey = sort2(sy, ey)
  local dm = deadwall_make(sx, sy, ex, ey)
  if not deadwalls[dm] then deadwalls[dm] = {} end
  return deadwalls[dm]
end

local function isSolidWall(ax, ay, bx, by)
  local ai, bi = gitem(ax, ay), gitem(bx, by)
  if ai == bi then return false end
  if deadwall(ax, ay, bx, by).dead then return false end
  
  return true
end


-- 3dness requirements
-- * wall side
-- * wall edge
-- * wall top
-- * door (can be razorthin)
-- rack (put it as a billboard?)
-- * ground inside
-- * ground outside
-- street



local bloop = CreateFrame("Frame")
bloop:SetBackgroundColor(0.1, 0.1, 0.1)
bloop:SetAllPoints()
bloop:SetLayer(-1)

local width = 20
local height = 20

bloop:SetCoordinateScale(width / 2, height / 2, height * 4 / 3 * 1.05)



local bloopwhite = CreateFrame("Frame")

local thinnity = 0.5

local function desired_wall(ax, ay, bx, by)
  local ai, bi = gitem(ax, ay), gitem(bx, by)
  local ad, bd = get_door(ax, ay), get_door(bx, by)
  
  if not ai and not bi then return "open" end
  
  if ai and bi and ai ~= bi and not ad ~= not bd then return "3door" end
  
  if (ai or bi) and ai ~= bi then return "3wall" end
  
  return "empty"
end


local center_x, center_y = 10, 10

local cx, cy = 10, 18

local shards = {}

local viewx = 5
local viewy = viewx / 4 * 3
function bloopwhite:Render()

  gl.Clear("DEPTH_BUFFER_BIT")

  gl.Enable("DEPTH_TEST")
  gl.DepthMask(true)
  
  gl.Enable("ALPHA_TEST")
  gl.AlphaFunc("GREATER", 0.01)

  gl.MatrixMode("PROJECTION")
  gl.PushMatrix()
  gl.LoadIdentity()
  gl.Ortho(-viewx / 2, viewx / 2, -viewy / 2, viewy / 2, -30, 100.0)
  
  gl.MatrixMode("MODELVIEW")
  gl.PushMatrix()
  gl.LoadIdentity()
  
  gl.Rotate( 50, 1.0, 0.0, 0.0)
  gl.Rotate( 200.0, 0.0, 1.0, 0.0)
  gl.Scale( -1.0, 1.0, -1.0)
  
  gl.Translate(-center_x, 0, -center_y)
  
  gl.Color(1, 1, 1)
  
  for typ = 1, 10 do
  
    if typ == 5 then
      -- render road
      
      local tex = Texture("3road")
      tex:SetTexture()
      
      local tx, ty = tex:GetWidth() / tex:GetInternalWidth(), tex:GetHeight() / tex:GetInternalHeight()
      
      local vert = {}
      local tex = {}
      
      for i = 1, width, 4 do
        table.append(vert, {i, 0, 17, i + 4, 0, 17, i + 4, 0, 21, i, 0, 21})
        table.append(tex, {0, 0, tx, 0, tx, ty, 0, ty})
      end
      
      glutil.RenderArray("QUADS", 3, vert, nil, nil, 2, tex) 
  
      -- render characters
      local tex = Texture("bobbin")
      tex:SetTexture()
      
      local tx, ty = tex:GetWidth() / tex:GetInternalWidth(), tex:GetHeight() / tex:GetInternalHeight()
      
      local girlsize = 0.5
      local girlheight = 0.8
      glutil.RenderArray("QUADS", 3, {cx - girlsize / 2, girlheight, cy, cx + girlsize / 2, girlheight, cy, cx + girlsize / 2, 0, cy, cx - girlsize / 2, 0, cy}, nil, nil, 2, {0, 0, tx, 0, tx, ty, 0, ty})
    end
      
    local tid
    if typ == 1 then
      tid = "3wall"
    elseif typ == 2 then
      tid = "3wall_smashed"
    elseif typ == 3 then
      tid = "3outside"
    elseif typ == 4 then
      tid = "3rack"
    elseif typ == 5 then
      tid = "3rack_smashed"
    elseif typ == 6 then
      tid = "3ground"
    elseif typ == 7 then
      tid = "3ground_smashed"
    elseif typ == 8 then
      tid = "3door"
    elseif typ == 9 then
      tid = "3door_smashed"
    elseif typ == 10 then
      tid = "3ceil"
    end
    local tex = Texture(tid)
    tex:SetTexture()
    
    local tx, ty = tex:GetWidth() / tex:GetInternalWidth(), tex:GetHeight() / tex:GetInternalHeight()
    
    local coord = {}
    local tex = {}
    
    local wals = 0.05
    
    local function do_quad(x, y, dx, dy, texs, texe)
      table.append(coord, {x, 1, y, x + dx, 1, y + dy, x + dx, 0, y + dy, x, 0, y})
      table.append(tex, {texs, 0, texe, 0, texe, 1, texs, 1})
    end
    local function do_wall(x, y, dx, dy, ax, ay, bx, by)
      if tid == "3wall" or tid == "3wall_smashed" then
        local doit = false
        if tid == "3wall" and not deadwall(ax, ay, bx, by).dead then doit = true end
        if tid == "3wall_smashed" and deadwall(ax, ay, bx, by).dead then doit = true end
        if doit then
          do_quad(x + dy * wals, y + dx * wals, dx, dy, 0, 1)
          do_quad(x - dy * wals, y - dx * wals, dx, dy, 0, 1)
          do_quad(x - dy * wals, y - dx * wals, dy * wals * 2, dx * wals * 2, 0, wals * 2)
          do_quad(x + dx - dy * wals, y + dy - dx * wals, dy * wals * 2, dx * wals * 2, 0, wals * 2)
        end
      elseif tid == "3ceil" then
        if not deadwall(ax, ay, bx, by).dead then
          local sx, sy, ex, ey = x - dy * wals, y - dx * wals, x + dx + dy * wals, y + dy + dx * wals
          table.append(coord, {sx, 1.01, sy, ex, 1, sy, ex, 1, ey, sx, 1.01, ey})
          table.append(tex, {0, 0, 1, 0, 1, 1, 0, 1})
          table.append(coord, {sx, 1, sy, ex, 1.01, sy, ex, 1.01, ey, sx, 1, ey})
          table.append(tex, {0, 0, 1, 0, 1, 1, 0, 1})
          table.append(coord, {sx, 1.01, sy, ex, 1.01, sy, ex, 1, ey, sx, 1, ey})
          table.append(tex, {0, 0, 1, 0, 1, 1, 0, 1})
          table.append(coord, {sx, 1, sy, ex, 1, sy, ex, 1.01, ey, sx, 1.01, ey})
          table.append(tex, {0, 0, 1, 0, 1, 1, 0, 1})
        end
      elseif tid == "3door" or tid == "3door_smashed" then
        do_quad(x, y, dx, dy, 0, 1)
      end
    end
    
    for x = 1, width + 1 do
      for y = 1, 17 do
        if tid == "3ground" and y < 17 then
          if gitem(x, y) and not get_smashed(x, y) then
            table.append(coord, {x, 0, y, x + 1, 0, y, x + 1, 0, y + 1, x, 0, y + 1})
            table.append(tex, {0, 0, 1, 0, 1, 1, 0, 1})
          end
        end
        if tid == "3ground_smashed" and y < 17 then
          if gitem(x, y) and get_smashed(x, y) then
            table.append(coord, {x, 0, y, x + 1, 0, y, x + 1, 0, y + 1, x, 0, y + 1})
            table.append(tex, {0, 0, 1, 0, 1, 1, 0, 1})
          end
        end
        if tid == "3outside" then
          if not gitem(x, y) then
            table.append(coord, {x, 0.9, y, x + 1, 0.9, y, x + 1, 0.9, y + 1, x, 0.9, y + 1})
            table.append(tex, {0, 0, 1, 0, 1, 1, 0, 1})
          end
        end
        
        if tid == "3rack" then
          if gitem(x, y) and get_rack(x, y) == true then
            local racksize = 0.9
            glutil.RenderArray("QUADS", 3, {x + 0.5 - racksize / 2, racksize, y + 0.5, x + 0.5 + racksize / 2, racksize, y + 0.5, x + 0.5 + racksize / 2, 0, y + 0.5, x + 0.5 - racksize / 2, 0, y + 0.5}, nil, nil, 2, {0, 0, tx, 0, tx, ty, 0, ty})
          end
        end
        
        if tid == "3rack_smashed" then
          if gitem(x, y) and get_rack(x, y) == "smashed" then
            local racksize = 0.9
            glutil.RenderArray("QUADS", 3, {x + 0.5 - racksize / 2, racksize, y + 0.5, x + 0.5 + racksize / 2, racksize, y + 0.5, x + 0.5 + racksize / 2, 0, y + 0.5, x + 0.5 - racksize / 2, 0, y + 0.5}, nil, nil, 2, {0, 0, tx, 0, tx, ty, 0, ty})
          end
        end
        
        if tid == "3wall" or tid == "3wall_smashed" or tid == "3ceil" then
          if x <= width then
            -- do what's above us
            if desired_wall(x, y, x, y - 1) == "3wall" then
              do_wall(x, y, 1, 0, x, y, x, y - 1)
            end
          end
          
          if y <= 16 then
            -- do what's to the left us
            if desired_wall(x, y, x - 1, y) == "3wall" then
              do_wall(x, y, 0, 1, x, y, x - 1, y)
            end
          end
        end
        
        
        if tid == "3door" or tid == "3door_smashed" then
          if x <= width then
            -- do what's above us
            if desired_wall(x, y, x, y - 1) == "3door" then
              if tid == "3door" and not deadwall(x, y, x, y - 1).dead then do_wall(x, y, 1, 0) end
              if tid == "3door_smashed" and deadwall(x, y, x, y - 1).dead then do_wall(x, y, 1, 0) end
            end
          end
          
          if y <= 16 then
            -- do what's to the left us
            if desired_wall(x, y, x - 1, y) == "3door" then
              if tid == "3door" and not deadwall(x, y, x - 1, y).dead then do_wall(x, y, 0, 1) end
              if tid == "3door_smashed" and deadwall(x, y, x - 1, y).dead then do_wall(x, y, 0, 1) end
            end
          end
        end
      end
    end
    
    while #tex / 2 < #coord / 3 do
      table.insert(tex, 0)
      table.insert(tex, 0)
      table.insert(tex, tx)
      table.insert(tex, 0)
      table.insert(tex, tx)
      table.insert(tex, ty)
      table.insert(tex, 0)
      table.insert(tex, ty)
    end
    
    glutil.RenderArray("QUADS", 3, coord, nil, nil, 2, tex)
  end
  
  local newshards = {}
  
  --gl.BlendFunc("SRC_ALPHA", "ONE");
  gl.Color(1, 1, 1, 0.5)
  gl.DepthMask(false)
  
  local tpf = 8
  for i = 1, 4 do
    local sd = (i - 1) * tpf
    local ed = i * tpf
    
    local tex = Texture("boom_" .. i)
    tex:SetTexture()
    
    local tx, ty = tex:GetWidth() / tex:GetInternalWidth(), tex:GetHeight() / tex:GetInternalHeight()
    
    local coord = {}
    local tex = {}
        
    local explos = 0.3
    
    for _, v in ipairs(shards) do
      if v.age >= sd and v.age < ed then
        local adx, ady, adz = explos, explos, 0
        local bdx, bdy, bdz = explos, -explos, 0
        local cdx, cdy, cdz = -explos, -explos, 0
        local ddx, ddy, ddz = -explos, explos, 0
        
        ady, adz = rotate(ady, adz, v.xang)
        bdy, bdz = rotate(bdy, bdz, v.xang)
        cdy, cdz = rotate(cdy, cdz, v.xang)
        ddy, ddz = rotate(ddy, ddz, v.xang)
        
        adx, adz = rotate(adx, adz, v.yang)
        bdx, bdz = rotate(bdx, bdz, v.yang)
        cdx, cdz = rotate(cdx, cdz, v.yang)
        ddx, ddz = rotate(ddx, ddz, v.yang)
        
        adx, ady = rotate(adx, ady, v.zang)
        bdx, bdy = rotate(bdx, bdy, v.zang)
        cdx, cdy = rotate(cdx, cdy, v.zang)
        ddx, ddy = rotate(ddx, ddy, v.zang)
        
        table.append(coord, {
          v.x + adx, v.z + ady, v.y + adz,
          v.x + bdx, v.z + bdy, v.y + bdz,
          v.x + cdx, v.z + cdy, v.y + cdz,
          v.x + ddx, v.z + ddy, v.y + ddz,
        })
        table.append(tex, {0, 0, tx, 0, tx, ty, 0, ty})
        
        table.insert(newshards, v)
      end
    end
        
    glutil.RenderArray("QUADS", 3, coord, nil, nil, 2, tex)
  end
  
  gl.Color(1, 1, 1, 1)
  gl.DepthMask(true)
  gl.BlendFunc("SRC_ALPHA", "ONE_MINUS_SRC_ALPHA");
  
  shards = newshards
  
  SetNoTexture()
  
  gl.MatrixMode("PROJECTION")
  gl.PopMatrix()
  gl.MatrixMode("MODELVIEW")
  gl.PopMatrix()
  
  gl.Disable("DEPTH_TEST")
  gl.Disable("ALPHA_TEST")
end

local speed = 0.03
local bound = 0.2

local dynbg = CreateFrame("Frame")

dynbg:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 5, 5)
dynbg:SetBackgroundColor(0, 0, 0, 0.5)
dynbg:SetLayer(100)

local dynindicator = CreateFrame("Text", dynbg)
dynindicator:SetLayer(5)

dynindicator:SetColor(1, 1, 1)

dynindicator:SetPoint("TOPLEFT", dynbg, "TOPLEFT", 10, 5)

dynbg:SetPoint("BOTTOMRIGHT", dynindicator, "BOTTOMRIGHT", 10, 5)

local dynamite_left = 2
local dynamite_pieces = 0
local kabooms = {}

local explorun = 0
local explodone = 0
local explotime

local function update_dyn()
  dynindicator:SetText(string.format("Dynamite left: %d uses", dynamite_left))
end
update_dyn()

local stepping = 0
local step_dur = 15

function tick_loop()
  local nx, ny = cx, cy
  if IsKeyDownFrame("arrow_up") then ny = ny - speed end
  if IsKeyDownFrame("arrow_down") then ny = ny + speed end
  if IsKeyDownFrame("arrow_left") then nx = nx - speed end
  if IsKeyDownFrame("arrow_right") then nx = nx + speed end
  
  if nx == cx and ny == cy then
    stepping = 0
  else
    stepping = stepping + 1
    if stepping >= step_dur then
      PlaySound("step")
      stepping = 0
    end
  end
  
  local function is_wall(sx, sy, ex, ey)
    if desired_wall(sx, sy, ex, ey) == "3wall" and not deadwall(sx, sy, ex, ey).dead then return true end
  end
  
  local function works(x, y)
    local mx, my = math.floor(x + bound), math.floor(y + bound)
    local nx, ny = math.floor(x - bound), math.floor(y - bound)
    
    if mx ~= nx then
      if is_wall(nx, ny, mx, ny) then return false end
    end
    
    if my ~= ny then
      if is_wall(nx, ny, nx, my) then return false end
    end
    
    if mx ~= nx and my ~= ny then
      if is_wall(mx, ny, mx, my) then return false end
      if is_wall(nx, my, mx, my) then return false end
    end
    
    return true
  end
  
  if works(nx, ny) then
    cx, cy = nx, ny
  elseif works(cx, ny) then
    cx, cy = cx, ny
  elseif works(nx, cy) then
    cx, cy = nx, cy
  end
  
  center_x = approach(center_x, cx, 1, 1)
  center_y = approach(center_y, cy, 1, 1)
  
  if WasKeyPressed("z") and dynamite_left > 0 then
    dynamite_left = dynamite_left - 1
    explorun = explorun + 1
    update_dyn()
    local lokup = {xp = {1, 0, "xm"}, xm = {-1, 0, "xp"}, yp = {0, 1, "ym"}, ym = {0, -1, "yp"}}
    table.insert(kabooms, coroutine.wrap(function ()
      local blasts = {}
      local sx, sy = math.floor(cx), math.floor(cy)
      local function make(x, y)
        return string.format("%d:%d", x, y)
      end
      local function shred(x)
        local x, y = x:match("(%d+):(%d+)")
        return tonumber(x), tonumber(y)
      end
      blasts[make(sx, sy)] = {xp = true, xm = true, yp = true, ym = true}
      
      local cycs = 4
      
      for i = 1, cycs do
        print("-- BLAST TIER")
        PlaySound("explode")
        for k, v in pairs(blasts) do
          local x, y = shred(k)
          local shft = 0.03
          local mov = 0.03
          for i = 1, 30 do
            table.insert(shards, {age = math.random() * 20, x = x + math.random(), y = y + math.random(), z = math.random(), xang = math.random() * 3.14159, yang = math.random() * 3.14159, zang = math.random() * 3.14159, xangd = math.random() * shft, yangd = math.random() * shft, zangd = math.random() * shft, xd = math.random() * mov - mov / 2, yd = math.random() * mov - mov / 2, zd = math.random() * mov - mov / 2})
          end
          print(k, v.xp, v.xm, v.yp, v.ym)
        end
        
        -- make effects here
        
        if i == cycs then break end
        
        coroutine.pause(15) -- blast delay
        
        local walldamages = {}
        
        local newb = {}
        for k, v in pairs(blasts) do
          local x, y = shred(k)
          
          for dir, dat in pairs(lokup) do
            if v[dir] then
              if isSolidWall(x, y, x + dat[1], y + dat[2]) then
                if gitem(x + dat[1], y + dat[2]) then
                  walldamages[string.format("%d:%d:%d:%d", x, y, x + dat[1], y + dat[2])] = true
                end
                
                dir = dat[3] -- we're going the opposite direction now
                dat = {0, 0, nil} -- but not moving
              end
              
              local result = make(x + dat[1], y + dat[2])
              if not newb[result] then
                newb[result] = {}
              end
              
              for passdir, passdat in pairs(lokup) do
                -- check for inversion
                if dat[3] ~= passdir and v[passdir] then
                  newb[result][passdir] = true
                end
              end
              
              newb[result][dir] = true -- need this in case we've reflected
            end
          end
        end
        
        for k in pairs(walldamages) do
          local ax, ay, bx, by = k:match("(%d+):(%d+):(%d+):(%d+)")
          deadwall(ax, ay, bx, by).dead = true
          print("deadifying ", ax, ay, bx, by)
        end
        for k in pairs(newb) do
          local x, y = shred(k)
          if get_rack(x, y) == true then
            dynamite_pieces = dynamite_pieces + 1
            if dynamite_pieces == 4 then
              dynamite_pieces = 0
              dynamite_left = dynamite_left + 1
              update_dyn()
            end
            set_rack(x, y, "smashed")
          end
          set_smashed(x, y, true)
        end
        blasts = newb
      end
      
      explodone = explodone + 1
      
      while true do
        coroutine.yield()
      end
    end))
  end
  
  for _, v in ipairs(kabooms) do
    v()
  end
  
  for _, v in ipairs(shards) do
    v.age = v.age + 1
    v.xang = v.xang + v.xangd
    v.yang = v.yang + v.yangd
    v.zang = v.zang + v.zangd
    v.x = v.x + v.xd
    v.y = v.y + v.yd
    v.z = v.z + v.zd
  end
  
  if dynamite_left == 0 and explodone == explorun then
    if not explotime then explotime = 0 end
    explotime = explotime + 1
    
    if explotime > 60 and not made_ood then
      local ood = CreateFrame("Text")
      ood:SetText("Out of dynamite! Time to go home!")
      
      ood:SetPoint("CENTER", UIParent, "CENTER")
      ood:SetSize(40)
      ood:SetBorder(true)
      ood:SetColor(1, 0.5, 0.5)
      ood:SetLayer(100)
      
      made_ood = true
    end
    
    if explotime > 60 + 240 then
      -- we should display a message here, then return later
      local destroyed_tiles, destroyed_rooms, destroyed_walls = 0, 0, 0
      local roomstatus = {}
      
      for x = 1, width + 1 do
        for y = 1, 17 do
          if gitem(x, y) and get_smashed(x, y) and gitem(x, y) ~= -1 then
            destroyed_tiles = destroyed_tiles + 1
          end
          
          if gitem(x, y) and gitem(x, y) ~= -1 then
            if get_smashed(x, y) then
              if not roomstatus[gitem(x, y)] then roomstatus[gitem(x, y)] = "smashed" end
            else
              roomstatus[gitem(x, y)] = "alive"
            end
          end
        
          if x <= width then
            -- do what's above us
            if desired_wall(x, y, x, y - 1) == "3wall" or desired_wall(x, y, x, y - 1) == "3door" then
              if deadwall(x, y, x, y - 1).dead then
                destroyed_walls = destroyed_walls + 1
              end
            end
          end
          
          if y <= 16 then
            -- do what's to the left of us
            if desired_wall(x, y, x - 1, y) == "3wall" or desired_wall(x, y, x - 1, y) == "3door" then
              if deadwall(x, y, x - 1, y).dead then
                destroyed_walls = destroyed_walls + 1
              end
            end
          end
        end
      end
      
      for _, v in pairs(roomstatus) do
        if v == "smashed" then
          destroyed_rooms = destroyed_rooms + 1
        end
      end
          
      results = {destroyed_tiles = destroyed_tiles, destroyed_rooms = destroyed_rooms, destroyed_walls = destroyed_walls}
    end
  end
end
