
local bg = CreateFrame("Frame")
bg:SetAllPoints()
bg:SetLayer(-100)
bg:SetBackgroundColor(0, 0.2, 0)

local buttonscreen = CreateFrame("Frame")
buttonscreen:SetLayer(-1)

local boyclicked = false
local boybutton = CreateFrame("Button", buttonscreen)
local boypic = CreateFrame("Texture", boybutton)
boypic:SetTexture("bob_head")
boypic:SetPoint("CENTER", UIParent, "CENTER", -165, 0)
boypic:SetLayer(1)
function boybutton:Click()
  boyclicked = true
end
local boytex = CreateFrame("Text", boybutton)
boytex:SetColor(1, 1, 1)
boytex:SetText("Play as a boy!")
boytex:SetPoint(0.5, 0, boypic, 0.5, 1, -35, 0)
boytex:SetSize(35)

local girlclicked = false
local girlbutton = CreateFrame("Button", buttonscreen)
local girlpic = CreateFrame("Texture", girlbutton)
girlpic:SetTexture("bobbin_head")
girlpic:SetPoint("CENTER", UIParent, "CENTER", 235, 0)
function girlbutton:Click()
  girlclicked = true
end
local girltex = CreateFrame("Text", girlbutton)
girltex:SetColor(1, 1, 1)
girltex:SetText("Play as a girl!")
girltex:SetPoint(0.5, 0, girlpic, 0.5, 1, -35, 0)
girltex:SetSize(35)

local bigtext = CreateFrame("Text")
bigtext:SetSize(55)
bigtext:SetPoint("CENTER", UIParent, "CENTER", 0, 250)
bigtext:SetColor(1, 0.5, 0.5)

local scorescreen = CreateFrame("Frame")
scorescreen:Hide()

local bobfrag = CreateFrame("Frame", scorescreen)
bobfrag:SetPoint("TOPLEFT", UIParent, 0, 0)
bobfrag:SetPoint("BOTTOMRIGHT", UIParent, 1, 0.4)

bobfrag:SetBackgroundColor(0, 0, 0.3)
bobfrag:SetLayer(-1)

local bobbinfrag = CreateFrame("Frame", scorescreen)
bobbinfrag:SetPoint("TOPLEFT", UIParent, 0, 0.4)
bobbinfrag:SetPoint("BOTTOMRIGHT", UIParent, 1, 0.8)

bobbinfrag:SetBackgroundColor(0.3, 0, 0)
bobbinfrag:SetLayer(-1)

local totalfrag = CreateFrame("Frame", scorescreen)
totalfrag:SetPoint("TOPLEFT", UIParent, 0, 0.8)
totalfrag:SetPoint("BOTTOMRIGHT", UIParent, 1, 1.0)

local ratframe = CreateFrame("Frame", totalfrag)
ratframe:Hide()

totalfrag:SetBackgroundColor(0.2, 0.2, 0.2)
totalfrag:SetLayer(-1)

local ratings = {}
local pos = 0.5
local function make_rating(name, score)
  local skor = CreateFrame("Frame", ratframe)
  local bigtext = CreateFrame("Text", skor)
  bigtext:SetText(name)
  bigtext:SetSize(70)
  bigtext:SetColor(1, 1, 1)
  bigtext:SetPoint("CENTER", skor, "CENTER", 0, -5)
  local smalltext = CreateFrame("Text", skor)
  smalltext:SetText(score .. " billion")
  smalltext:SetSize(15)
  smalltext:SetColor(1, 1, 1)
  smalltext:SetPoint("CENTER", skor, "CENTER", 0, 30)
  
  local box = CreateFrame("Frame", skor)
  box:SetPoint("CENTER", skor, "CENTER")
  box:SetSize(70)
  box:SetLayer(2)
  
  box:SetBackgroundColor(0, 0, 0, 0.6)
  
  skor:SetPoint("CENTER", totalfrag, pos / 6, 1, 0, -50)  
  pos = pos + 1
  
  table.insert(ratings, {bg = box, tot = score})
end
make_rating("F", 0)
make_rating("D", 10)
make_rating("C", 300)
make_rating("B", 2000)
make_rating("A", 50000)
make_rating("A+", 100000)

--local function 

local bob = CreateFrame("Texture", scorescreen)
bob:SetTexture("bob")
bob:SetPoint("TOPLEFT", bobfrag, "TOPLEFT")

local bobbin = CreateFrame("Texture", scorescreen)
bobbin:SetTexture("bobbin")
bobbin:SetPoint("BOTTOMRIGHT", bobbinfrag, "BOTTOMRIGHT")

local click2 = CreateFrame("Text", bobfrag)
click2:SetText("Click to continue!")
click2:SetColor(1, 1, 1)
click2:SetSize(40)
click2:SetPoint("CENTER", UIParent, "CENTER", 0, 80)

local function createStdScore(name, text, yps, context)
  local prefix = "score_" .. name
  local meta = CreateFrame("Frame", context)
  
  local titl = CreateFrame("Text", meta)
  titl:SetText(text)
  titl:SetSize(40)
  titl:SetPoint(1, 0.5, context, 0.5, 0, -50, yps)
  titl:SetColor(1, 1, 1)
  
  local pts = CreateFrame("Text", meta)
  pts:SetText("64")
  pts:SetSize(40)
  pts:SetPoint(0, 0.5, context, 0.5, 0, 50, yps)
  pts:SetColor(1, 1, 1)
  
  local accum = CreateFrame("Text", meta)
  accum:SetText("7 built! One more would have increased your score by 1283745!")
  accum:SetSize(20)
  accum:SetPoint(0.5, 0.5, context, 0.5, 0, 0, yps + 25)
  accum:SetColor(1, 1, 1)
  
  _G[prefix] = meta
  _G[prefix .. "_title"] = titl
  _G[prefix .. "_points"] = pts
  _G[prefix .. "_accumulate"] = accum
end

local tottext = CreateFrame("Text", totalfrag)
tottext:SetSize(40)
tottext:SetColor(1, 1, 1)
tottext:SetText("Your score:")
tottext:SetPoint(1, 0.5, totalfrag, 0.5, 0, -50, 40)

local totsc = CreateFrame("Text", totalfrag)
totsc:SetSize(40)
totsc:SetColor(1, 1, 1)
totsc:SetPoint(0, 0.5, totalfrag, 0.5, 0, 50, 40)

createStdScore("built_racks", "Built rack score", 75, bobfrag)
createStdScore("built_rooms", "Built room score", 150, bobfrag)
createStdScore("built_doors", "Built door score", 225, bobfrag)
createStdScore("destroyed_tiles", "Destroyed tile score", 75, bobbinfrag)
createStdScore("destroyed_rooms", "Destroyed room score", 150, bobbinfrag)
createStdScore("destroyed_walls", "Destroyed wall score", 225, bobbinfrag)


local function calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls)
  if not built_racks or not built_rooms or not built_doors or not destroyed_tiles or not destroyed_rooms or not destroyed_walls then
    local rv = {}
    if built_racks then rv[1] = math.pow(built_racks, 1.5) * 10 end
    if built_rooms then rv[2] = math.pow(built_rooms, 1.0) * 10 end
    if built_doors then rv[3] = math.pow(built_doors, 0.5) * 10 end
    if destroyed_tiles then rv[4] = math.pow(destroyed_tiles, 0.2) * 10 end
    if destroyed_rooms then rv[5] = math.pow(destroyed_rooms, 2.0) * 10 end
    if destroyed_walls then rv[6] = math.pow(destroyed_walls, 0.5) * 10 end
    return -1, unpack(rv)
  end
  return
    math.pow(built_racks, 1.5) *
    math.pow(built_rooms, 1.0) *
    math.pow(built_doors, 0.5) *
    math.pow(destroyed_tiles, 0.2) *
    math.pow(destroyed_rooms, 2.0) *
    math.pow(destroyed_walls, 0.5)
     * 1000000,
    math.pow(built_racks, 1.5) * 10,
    math.pow(built_rooms, 1.0) * 10,
    math.pow(built_doors, 0.5) * 10,
    math.pow(destroyed_tiles, 0.2) * 10,
    math.pow(destroyed_rooms, 2.0) * 10,
    math.pow(destroyed_walls, 0.5) * 10
end

local function upditem(targ, amt, this, diff, bd)
  print(targ, amt, this, diff, bd)
  if this then
    _G["score_" .. targ]:Show()
    _G["score_" .. targ .. "_points"]:SetText(string.format("%.1f", this))
    if diff > 0 then
      _G["score_" .. targ .. "_accumulate"]:SetText(string.format("%d %s! One more would increase your score by %.1f billion!", amt, bd, diff / 1000000000))
      _G["score_" .. targ .. "_accumulate"]:Show()
    else
      _G["score_" .. targ .. "_accumulate"]:Hide()
    end
  else
    _G["score_" .. targ]:Hide()
  end
end

local function updinfo(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls, showbig)
  if built_racks then
    upditem("built_racks", built_racks, select(2, calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls)), calc_score(built_racks + 1, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls) - calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls), "built")
  else
    upditem("built_racks")
  end
  if built_rooms then
    upditem("built_rooms", built_rooms, select(3, calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls)), calc_score(built_racks, built_rooms + 1, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls) - calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls), "built")
  else
    upditem("built_rooms")
  end
  if built_doors then
    upditem("built_doors", built_doors, select(4, calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls)), calc_score(built_racks, built_rooms, built_doors + 1, destroyed_tiles, destroyed_rooms, destroyed_walls) - calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls), "built")
    click2:Show()
  else
    upditem("built_doors")
    click2:Hide()
  end
  if destroyed_tiles then
    upditem("destroyed_tiles", destroyed_tiles, select(5, calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls)), calc_score(built_racks, built_rooms, built_doors, destroyed_tiles + 1, destroyed_rooms, destroyed_walls) - calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls), "destroyed")
  else
    upditem("destroyed_tiles")
  end
  if destroyed_rooms then
    upditem("destroyed_rooms", destroyed_rooms, select(6, calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls)), calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms + 1, destroyed_walls) - calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls), "destroyed")
  else
    upditem("destroyed_rooms")
  end
  if destroyed_walls then
    upditem("destroyed_walls", destroyed_walls, select(7, calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls)), calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls + 1) - calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls), "destroyed")
  
    tottext:Show()
    totsc:Show()
    ratframe:Show()
  else
    tottext:Hide()
    totsc:Hide()
    ratframe:Hide()
    
    upditem("destroyed_walls")
  end
  
  if showbig then
    
    bobfrag:SetPoint("BOTTOMRIGHT", UIParent, 1, 0.5)
    bobbinfrag:Show()
    bobbin:Show()
    totalfrag:Show()
    
    click2:Hide()
  else
    
    bobfrag:SetPoint("BOTTOMRIGHT", UIParent, 1, 1)
    bobbinfrag:Hide()
    bobbin:Hide()
    totalfrag:Hide()
  end
  
  local tsc = calc_score(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls) / 1000000000
  --if tsc >= 1000 then
    --totsc:SetText(string.format("%d,%d BILLION", math.floor(tsc / 1000), tsc - math.floor(tsc / 1000) * 1000))
  if tsc >= 10 then
    totsc:SetText(string.format("%d BILLION", tsc))
  else
    totsc:SetText(string.format("%.4f BILLION", tsc))
  end
  
  local lst = nil
  for _, v in ipairs(ratings) do
    if v.tot <= tsc then
      lst = v
    end
  end
  if lst then
    lst.bg:SetBackgroundColor(1, 1, 1, 0.3)
  end
end



local bobintro = CreateFrame("Frame")
bobintro:SetAllPoints()
bobintro:SetBackgroundColor(0, 0, 0.3)
bobintro:Hide()

local bobintrobob = CreateFrame("Texture", bobintro)
bobintrobob:SetTexture("bob")
bobintrobob:SetPoint("TOPLEFT", bobintro, "TOPLEFT")

local bobintrotext = CreateFrame("Text_Multiline", bobintro)
bobintrotext:SetPoint("TOPLEFT", bobintrobob, "TOPRIGHT", 30, 30)
bobintrotext:SetPoint("RIGHT", UIParent, "RIGHT", -30, -30)
bobintrotext:SetColor(1, 1, 1)
bobintrotext:SetSize(1.0)
bobintrotext:SetText(
[[This is a boy!

Say hi to this boy.

Hello, boy!

This boy has gotten a contract from a gigantic corporation. They want to build a mall!

Wow! A mall! Can you think of anything more exciting?

Why don't you help him design the mall?

You want to make a profitable mall, so you'll have to keep some things in mind. A mall is going to need a lot of rooms, of course. And it will need doors to connect the rooms, plus doors are pretty. Everyone likes doors. And it will need clothing racks! Lots of clothing racks. You can't sell anything without clothing racks!

If you have all of those three things, you'll have an awesome mall!

Why don't you get out there and build the best mall you can?



(Click to continue.)]])
bobintrotext:ForceHeight()



local bobbinintro = CreateFrame("Frame")
bobbinintro:SetAllPoints()
bobbinintro:SetBackgroundColor(0.3, 0, 0)
bobbinintro:Hide()

local bobbinintrobob = CreateFrame("Texture", bobbinintro)
bobbinintrobob:SetTexture("bobbin")
bobbinintrobob:SetPoint("TOPRIGHT", bobintro, "TOPRIGHT", 0, 30)

local bobbinintrotext = CreateFrame("Text_Multiline", bobbinintro)
bobbinintrotext:SetPoint("TOPRIGHT", bobbinintrobob, "TOPLEFT", 50, 0)
bobbinintrotext:SetPoint("LEFT", UIParent, "LEFT", 30, -30)
bobbinintrotext:SetColor(1, 1, 1)
bobbinintrotext:SetSize(0.8)
bobbinintrotext:SetText(
[[This is a girl!

Say hi to this girl.

Hello, girl!

This girl has decided on a goal for herself. She wants to BLOW THE SHIT OUT OF A MALL!

Wow! Blowing up a mall! Can you think of anything more exciting?

Why don't you help her destroy the mall?

You want to do a lot of damage to the mall, so you'll have to keep some things in mind. Every square of the mall you destroy will cost them a lot to fix. Walls are expensive, as are doors, though not any more so than walls. (Why would anyone care about doors? That's just silly.) Also, you're a bit of a completionist, so every entire room you destroy will give you a big bonus.

You don't really care about clothing racks because they can be replaced, but unfortunately you're a little low on dynamite. Luckily, your friends have stashed explosives in the clothing racks! You don't care about the racks for their own sake, but every time you destroy four of them you'll get more dynamite to play with.

If you do all that stuff, you'll cause a ton of damage to the mall!

You sure do hope this mall will be laid-out well. If it wasn't laid out properly for you, you might not be able to do much damage. But it's not like you had any control over the layout. So it certainly isn't something you could fix, on a second playthrough, or anything like that. Right?

Why don't you get out there and blow up a mall as well as you can?



(Use arrow keys to move and Z to set explosives. Click to continue.)]])
bobbinintrotext:ForceHeight()



local delay = 12



local uicenter

tick_loop = coroutine.wrap(function ()
  while true do
    if boyclicked then break end
    if girlclicked then
      bigtext:SetText("You cannot be a girl first! That is not allowed!")
    end
    boyclicked = false
    girlclicked = false
    coroutine.yield()
  end
  
  boyclicked = false
  girlclicked = false
  
  bigtext:SetText("")
  
  bobintro:Show()
  while not WasKeyPressed("mouse_left") and not WasKeyPressed("space") and not WasKeyPressed("enter") do
    coroutine.yield()
  end
  bobintro:Hide()
  
  print("Boy start here")
  uicenter = runuifile("boy.lua")
  
  while not uicenter.results do
    coroutine.yield()
  end
  
  uicenter.UIRoot:Detach()

  local stash = uicenter.results
  
  local built_racks, built_rooms, built_doors = stash.built_racks, stash.built_rooms, stash.built_doors
  
  scorescreen:Show()
  updinfo(nil, nil, nil, nil, nil, nil)
  coroutine.pause(delay * 3)
  PlaySound("stomp")
  updinfo(built_racks, nil, nil, nil, nil, nil)
  coroutine.pause(delay)
  PlaySound("stomp")
  updinfo(built_racks, built_rooms, nil, nil, nil, nil)
  coroutine.pause(delay)
  PlaySound("stomp")
  updinfo(built_racks, built_rooms, built_doors, nil, nil, nil)
  
  while not WasKeyPressed("mouse_left") and not WasKeyPressed("space") and not WasKeyPressed("enter") do
    coroutine.yield()
  end
  scorescreen:Hide()
  
  local done = CreateFrame("Texture", boypic)
  done:SetTexture("done")
  done:SetPoint("CENTER", boypic, "CENTER", -35, 0)
  done:SetLayer(1)
  
  coroutine.pause(10)
  girlclicked = false
  boyclicked = false
  
  while true do
    if girlclicked then break end
    if boyclicked then
      bigtext:SetText("You have already been a boy! You cannot do it again.")
    end
    boyclicked = false
    girlclicked = false
    coroutine.yield()
  end
  
  bigtext:SetText("")
  
  bobbinintro:Show()
  while not WasKeyPressed("mouse_left") and not WasKeyPressed("space") and not WasKeyPressed("enter") do
    coroutine.yield()
  end
  bobbinintro:Hide()
  
  uicenter = runuifile("girl.lua", stash)
  
  while not uicenter.results do
    uicenter.tick_loop()
    coroutine.yield()
  end
  
  uicenter.UIRoot:Detach()
  
  local destroyed_tiles = uicenter.results.destroyed_tiles
  local destroyed_rooms = uicenter.results.destroyed_rooms
  local destroyed_walls = uicenter.results.destroyed_walls
  
  scorescreen:Show()
  updinfo(nil, nil, nil, nil, nil, nil, true)
  coroutine.pause(delay * 3)
  PlaySound("stomp")
  updinfo(built_racks, nil, nil, nil, nil, nil, true)
  coroutine.pause(delay)
  PlaySound("stomp")
  updinfo(built_racks, built_rooms, nil, nil, nil, nil, true)
  coroutine.pause(delay)
  PlaySound("stomp")
  updinfo(built_racks, built_rooms, built_doors, nil, nil, nil, true)
  coroutine.pause(delay)
  PlaySound("stomp")
  updinfo(built_racks, built_rooms, built_doors, destroyed_tiles, nil, nil, true)
  coroutine.pause(delay)
  PlaySound("stomp")
  updinfo(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, nil, true)
  coroutine.pause(delay)
  PlaySound("stomp")
  updinfo(built_racks, built_rooms, built_doors, destroyed_tiles, destroyed_rooms, destroyed_walls, true)
  
  coroutine.pause(180)
  
  local restart = CreateFrame("Button")
  restart:SetLayer(100)
  local restext = CreateFrame("Text", restart)
  restext:SetColor(1, 1, 1)
  restext:SetSize(30)
  restext:SetText("Restart")
  local resbg = CreateFrame("Frame", restart)
  resbg:SetLayer(-1)
  resbg:SetBackgroundColor(0, 0, 0, 0.5)
  resbg:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -10, 10)
  restext:SetPoint("TOPRIGHT", resbg, "TOPRIGHT", -10, 5)
  resbg:SetPoint("BOTTOMLEFT", restext, "BOTTOMLEFT", -10, 5)
  
  function restart:Click()
    GlorpController("exit_game")
  end
  
  while true do
    for i = 1, 2 do
      resbg:SetBackgroundColor(1, 1, 1, 0.5)
      coroutine.pause(10)
      resbg:SetBackgroundColor(0, 0, 0, 0.5)
      coroutine.pause(10)
    end
    
    coroutine.pause(600)
  end
  -- run final scoring
end)
